
/* 
 * Title       : C8051F330.h
 * Description : C8051F330
 * Author      : KAWAMOTO Yasuhisa
 * URL         : http://www.devdrv.co.jp/
 * Date        : 09/18/2003
 */

#ifndef __C8051_H
#define __C8051_H

// BYTE Registers
sfr at 0x80 P0;         // Port 0 Latch
sfr at 0x81 SP;         // Stack Pointer
sfr at 0x82 DPL;        // Data Pointer Low
sfr at 0x83 DPH;        // Data Pointer High
sfr at 0x87 PCON;       // Power Control
sfr at 0x88 TCON;       // Timer/Counter Control
sfr at 0x89 TMOD;       // Timer/Counter Mode
sfr at 0x8A TL0;        // Timer/Counter 0 Low
sfr at 0x8B TL1;        // Timer/Counter 1 Low
sfr at 0x8C TH0;        // Timer/Counter 0 High
sfr at 0x8D TH1;        // Timer/Counter 1 High
sfr at 0x8E CKCON;      // Clock Control
sfr at 0x8F PSCTL;      // Program Store R/W Control
sfr at 0x90 P1;         // Port 1 Latch
sfr at 0x91 TMR3CN;     // Timer/Counter 3Control
sfr at 0x92 TMR3RLL;    // Timer/Counter 3 Reload Low
sfr at 0x93 TMR3RLH;    // Timer/Counter 3 Reload High
sfr at 0x94 TMR3L;      // Timer/Counter 3Low
sfr at 0x95 TMR3H;      // Timer/Counter 3 High
sfr at 0x96 IDA0L;      // Current Mode DAC0 Low
sfr at 0x97 IDA0H;      // Current Mode DAC0 High
sfr at 0x98 SCON0;      // UART0 Control
sfr at 0x99 SBUF0;      // UART0 Data Buffer
sfr at 0x9B CPT0CN;     // Comparator0 Control
sfr at 0x9D CPT0MD;     // Comparator0 Mode Selection
sfr at 0x9F CPT0MX;     // Comparator0 MUX Selection
sfr at 0xA0 P2;         // Port 2 Latch
sfr at 0xA1 SPI0CFG;    // SPI Configuration
sfr at 0xA2 SPI0CKR;    // SPI Clock Rate Control
sfr at 0xA3 SPI0DAT;    // SPI Data
sfr at 0xA4 P0MDOUT;    // Port 0 Output Mode Configuration
sfr at 0xA5 P1MDOUT;    // Port 1 Output Mode Configuration
sfr at 0xA6 P2MDOUT;    // Port 2 Output Mode Configuration
sfr at 0xA8 IE;         // Interrupt Enable
sfr at 0xA9 CLKSEL;     // Clock Select
sfr at 0xAA EMI0CN;     // External Memory Interface Control
sfr at 0xB1 OSCXCN;     // External Oscillator Control
sfr at 0xB2 OSCICN;     // Internal Oscillator Control
sfr at 0xB3 OSCICL;     // Internal Oscillator Calibration
sfr at 0xB6 FLSCL;      // FLASH Scale
sfr at 0xB7 FLKEY;      // FLASH Lock and Key
sfr at 0xB8 IP;         // Interrupt Priority
sfr at 0xB9 IDA0CN;     // Current Mode DAC0 Control
sfr at 0xBA AMX0N;      // AMUX0 Negative Channel Select
sfr at 0xBB AMX0P;      // AMUX0 Positive Channel Select
sfr at 0xBC ADC0CF;     // ADC0 Configuration
sfr at 0xBD ADC0L;      // ADC0 Low
sfr at 0xBE ADC0H;      // ADC0 High
sfr at 0xC0 SMB0CN;     // SMBus Control
sfr at 0xC1 SMB0CF;     // SMBus Configuration
sfr at 0xC2 SMB0DAT;    // SMBus Data
sfr at 0xC3 ADC0GTL;    // ADC0 Greater-Than Compare Low
sfr at 0xC4 ADC0GTH;    // ADC0 Greater-Than Compare High
sfr at 0xC5 ADC0LTL;    // ADC0 Less-Than Compare Word Low
sfr at 0xC6 ADC0LTH;    // ADC0 Less-Than Compare Word High
sfr at 0xC8 TMR2CN;     // Timer/Counter 2 Control
sfr at 0xCA TMR2RLL;    // Timer/Counter 2 Reload Low
sfr at 0xCB TMR2RLH;    // Timer/Counter 2 Reload High
sfr at 0xCC TMR2L;      // Timer/Counter 2 Low
sfr at 0xCD TMR2H;      // Timer/Counter 2 High
sfr at 0xD0 PSW;        // Program Status Word
sfr at 0xD1 REF0CN;     // Voltage Reference Control
sfr at 0xD4 P0SKIP;     // Port 0 Skip
sfr at 0xD5 P1SKIP;     // Port 1 Skip
sfr at 0xD8 PCA0CN;     // PCA Control
sfr at 0xD9 PCA0MD;     // PCA Mode
sfr at 0xDA PCA0CPM0;   // PCA Module 0 Mode Register
sfr at 0xDB PCA0CPM1;   // PCA Module 1 Mode Register
sfr at 0xDC PCA0CPM2;   // PCA Module 2 Mode Register
sfr at 0xE0 ACC;        // Accumulator
sfr at 0xE1 XBR0;       // Port I/O Crossbar Control 0
sfr at 0xE2 XBR1;       // Port I/O Crossbar Control 1
sfr at 0xE3 OSCLCN;     // Low-Frequency Oscillator Control
sfr at 0xE4 IT01CF;     // INT0/INT1 Configuration
sfr at 0xE6 EIE1;       // Extended Interrupt Enable 1
sfr at 0xE8 ADC0CN;     // ADC0 Control
sfr at 0xE9 PCA0CPL1;   // PCA Capture 1 Low
sfr at 0xEA PCA0CPH1;   // PCA Capture 1 High
sfr at 0xEB PCA0CPL2;   // PCA Capture 2 Low
sfr at 0xEC PCA0CPH2;   // PCA Capture 2 High
sfr at 0xEF RSTSRC;     // Reset Source Configuration/Status
sfr at 0xF0 B;          // B Register
sfr at 0xF1 P0MDIN;     // Port 0 Input Mode Configuration
sfr at 0xF2 P1MDIN;     // Port 1 Input Mode Configuration
sfr at 0xF6 EIP1;       // Extended Interrupt Priority 1
sfr at 0xF8 SPI0CN;     // SPI Control
sfr at 0xF9 PCA0L;      // PCA Counter Low
sfr at 0xFA PCA0H;      // PCA Counter High
sfr at 0xFB PCA0CPL0;   // PCA Capture 0 Low
sfr at 0xFC PCA0CPH0;   // PCA Capture 0 High
sfr at 0xFF VDM0CN;     // VDD Monitor Control

// BIT Registers

// P0: Port0 Register
sbit at 0x80+0 P0_0;    // PORT0 bit0
sbit at 0x80+1 P0_1;    // PORT0 bit1
sbit at 0x80+2 P0_2;    // PORT0 bit2
sbit at 0x80+3 P0_3;    // PORT0 bit3
sbit at 0x80+4 P0_4;    // PORT0 bit4
sbit at 0x80+5 P0_5;    // PORT0 bit5
sbit at 0x80+6 P0_6;    // PORT0 bit6
sbit at 0x80+7 P0_7;    // PORT0 bit7

// TCON: Timer Control Register
sbit at 0x88+0 IT0;     // Interrupt 0 Type Select
sbit at 0x88+1 IE0;     // External Interrupt 0
sbit at 0x88+2 IT1;     // Interrupt 1 Type Select
sbit at 0x88+3 IE1;     // External Interrupt 1
sbit at 0x88+4 TR0;     // Timer 0 Run Control
sbit at 0x88+5 TF0;     // Timer 0 Overflow Flag
sbit at 0x88+6 TR1;     // Timer 1 Run Control
sbit at 0x88+7 TF1;     // Timer 1 Overflow Flag

// P1: Port1 Register
sbit at 0x90+0 P1_0;    // PORT1 bit0
sbit at 0x90+1 P1_1;    // PORT1 bit1
sbit at 0x90+2 P1_2;    // PORT1 bit2
sbit at 0x90+3 P1_3;    // PORT1 bit3
sbit at 0x90+4 P1_4;    // PORT1 bit4
sbit at 0x90+5 P1_5;    // PORT1 bit5
sbit at 0x90+6 P1_6;    // PORT1 bit6
sbit at 0x90+7 P1_7;    // PORT1 bit7

// SCON0: Serial Port 0 Control Register
sbit at 0x98+0 RI0;     // Receive Interrupt Flag
sbit at 0x98+1 TI0;     // Transmit Interrupt Flag
sbit at 0x98+2 RB80;    // Ninth Receive Bit
sbit at 0x98+3 TB80;    // Ninth Transmission Bit
sbit at 0x98+4 REN0;    // Receive Enable
sbit at 0x98+5 MCE0;    // Multiprocessor Communication Enable
sbit at 0x98+7 S0MODE;  // Serial Port 0 Operation Mode

// P2: Port2 Register
sbit at 0xA0+0 P2_0;    // PORT2 bit0
sbit at 0xA0+1 P2_1;    // PORT2 bit1
sbit at 0xA0+2 P2_2;    // PORT2 bit2
sbit at 0xA0+3 P2_3;    // PORT2 bit3
sbit at 0xA0+4 P2_4;    // PORT2 bit4
sbit at 0xA0+5 P2_5;    // PORT2 bit5
sbit at 0xA0+6 P2_6;    // PORT2 bit6
sbit at 0xA0+7 P2_7;    // PORT2 bit7

// IE: Interrupt Enable
sbit at 0xA8+0 EX0;     // Enable External Interrupt 0
sbit at 0xA8+1 ET0;     // Enable Timer 0 Interrupt
sbit at 0xA8+2 EX1;     // Enable External Interrupt 1
sbit at 0xA8+3 ET1;     // Enable Timer 1 Interrupt
sbit at 0xA8+4 ES0;     // Enable UART0 Interrupt
sbit at 0xA8+5 ET2;     // Enable Timer 2 Interrupt
sbit at 0xA8+6 ESPI0;   // Enable Serial Peripheral Interface (SPI0) Interrupt
sbit at 0xA8+7 EA;      // Enable All Interrupts

// IP: Interrupt Priority
sbit at 0xB8+0 PX0;     // External Interrupt 0 Priority Control
sbit at 0xB8+1 PT0;     // Timer 0 Interrupt Priority Control
sbit at 0xB8+2 PX1;     // External Interrupt 1 Priority Control
sbit at 0xB8+3 PT1;     // Timer 1 Interrupt Priority Control
sbit at 0xB8+4 PS0;     // UART0 Interrupt Priority Control
sbit at 0xB8+5 PT2;     // Timer 2 Interrupt Priority Control
sbit at 0xB8+6 PSPI0;   // Serial Peripheral Interface (SPI0) Interrupt Priority Control

// SMB0CN: SMBus Control Register
sbit at 0xC0+0 SI;      // SMBus Interrupt Flag
sbit at 0xC0+1 ACK;     // SMBus Acknowledge Flag
sbit at 0xC0+2 ARBLOST; // SMBus Arbitration Lost Indicator
sbit at 0xC0+3 ACKRQ;   // SMBus Acknowledge Request
sbit at 0xC0+4 STO;     // SMBus Stop Flag
sbit at 0xC0+5 STA;     // SMBus Start Flag
sbit at 0xC0+6 TXMODE;  // SMBus Transmit Mode Indicator
sbit at 0xC0+7 MASTER;  // SMBus Master/Slave Indicator

// TMR2CN:
sbit at 0xC8+0 T2XCLK;  // Timer 2 External Clock Select
sbit at 0xC8+2 TR2;     // Timer 2 Run Control
sbit at 0xC8+3 T2SPLIT; // Timer 2 Split Mode Enable
sbit at 0xC8+4 TF2CEN;  // Timer 2 Low-Frequency Oscillator Capture Enable
sbit at 0xC8+5 TF2LEN;  // Timer 2 Low Byte Interrupt Enable
sbit at 0xC8+6 TF2L;    // Timer 2 Low Byte Overflow Flag
sbit at 0xC8+7 TF2H;    // Timer 2 High Byte Overflow Flag

// PSW: Program Status Word
sbit at 0xD0+0 PARITY;  // Parity Flag
sbit at 0xD0+1 F1;      // User Flag 1
sbit at 0xD0+2 OV;      // Overflow Flag
sbit at 0xD0+3 RS0;     // Register Bank Select
sbit at 0xD0+4 RS1;     // Register Bank Select
sbit at 0xD0+5 F0;      // User Flag 0
sbit at 0xD0+6 AC;      // Auxiliary Carry Flag
sbit at 0xD0+7 CY;      // Carry Flag

// PCA0CN: PCA Control Register
sbit at 0xD8+0 CCF0;    // PCA Module 0 Capture/Compare Flag
sbit at 0xD8+1 CCF1;    // PCA Module 1 Capture/Compare Flag
sbit at 0xD8+2 CCF2;    // PCA Module 2 Capture/Compare Flag
sbit at 0xD8+6 CR;      // PCA Counter/Timer Run Control
sbit at 0xD8+7 CF;      // PCA Counter/Timer Overflow Flag

// ADC0CN: ADC0 Control Register
sbit at 0xE8+0 AD0CM0;  // ADC0 Start of Conversion Mode Select
sbit at 0xE8+1 AD0CM1;  // ADC0 Start of Conversion Mode Select
sbit at 0xE8+2 AD0CM2;  // ADC0 Start of Conversion Mode Select
sbit at 0xE8+3 AD0WINT; // ADC0 Window Compare Interrupt Flag
sbit at 0xE8+4 AD0BUSY; // ADC0 Busy Bit
sbit at 0xE8+5 AD0INT;  // ADC0 Conversion Complete Interrupt Flag
sbit at 0xE8+6 AD0TM;   // ADC0 Track Mode Bit
sbit at 0xE8+7 AD0EN;   // ADC0 Enable Bit

// SPI0CN: SPI0 Control Register
sbit at 0xF8+0 SPIEN;   // SPI0 Enable
sbit at 0xF8+1 TXBMT;   // Transmit Buf fer Empty
sbit at 0xF8+2 NSSMD0;  // Slave Select Mode
sbit at 0xF8+3 NSSMD1;  // Slave Select Mode
sbit at 0xF8+4 RXOVRN;  // Receive Overrun Flag (Slave Mode only)
sbit at 0xF8+5 MODF;    // Mode Fault Flag
sbit at 0xF8+6 WCOL;    // Write Collision Flag
sbit at 0xF8+7 SPIF;    // SPI0 Interrupt Flag

#endif
